## mia 2.2.0

=== CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2014 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

PROJECT("mia")

CMAKE_MINIMUM_REQUIRED(VERSION 2.8.5 FATAL_ERROR)

if(COMMAND cmake_policy)
  cmake_policy(SET CMP0003 NEW)
  cmake_policy(SET CMP0012 NEW)
endif(COMMAND cmake_policy)

include(FindPkgConfig)
include(CheckCXXSourceCompiles)

# Making releases:
#   MICRO_VERSION += 1;
#   INTERFACE_AGE += 1;
#   BINARY_AGE += 1;
# if any functions have been added, set INTERFACE_AGE to 0.
# if backwards compatibility has been broken,
# set BINARY_AGE and INTERFACE_AGE to 0.


SET(VENDOR "Gert Wollny")
SET(PACKAGE_NAME "mia")
SET(MAJOR_VERSION 2)
SET(MINOR_VERSION 2)
SET(MICRO_VERSION 0)
SET(INTERFACE_AGE 0)
SET(BINARY_AGE    0)

SET(PACKAGE_VERSION "${MAJOR_VERSION}.${MINOR_VERSION}.${MICRO_VERSION}")
SET(VERSION "${MAJOR_VERSION}.${MINOR_VERSION}")
SET(MIA_NAME "${PACKAGE_NAME}-${VERSION}")
SET(prefix ${CMAKE_INSTALL_PREFIX})
SET(PLUGIN_OUTPUT "${CMAKE_BINARY_DIR}/plugins")

SET(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

MATH(EXPR MIA_CURRENT "${MICRO_VERSION} - ${BINARY_AGE}")
SET(MIA_REVISION ${INTERFACE_AGE})
MATH(EXPR MIA_AGE "${BINARY_AGE} - ${INTERFACE_AGE}")

SET(LIBRARY_SOVERSION_INFO "${MIA_CURRENT}")
SET(LIBRARY_VERSION_INFO "${MIA_CURRENT}.${MIA_AGE}.${MIA_REVISION}")

OPTION(STRICT_DEPENDECIES "require that all requested optinal dependencies are availabe" FALSE)
OPTION(ALWAYS_CREATE_DOC "Create all documentation during the normal build process (normally you need to run 'make doc')" TRUE)
OPTION(BUILD_EXAMPLES "Build example plug-ins and programs" FALSE)
OPTION(ENABLE_DEBUG_MESSAGES "Enable debug and trace outputs" TRUE)

INCLUDE(GNUInstallDirs)

INCLUDE (CheckIncludeFiles)
INCLUDE (TestBigEndian)
INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/cmake/macros.cmake)
INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/cmake/pluginmacro.cmake)
INCLUDE (CheckTypeSize)

include(CheckCXXCompilerFlag)

IF(UNIX)
  CHECK_CXX_COMPILER_FLAG("-std=c++11" HAS_GNU_CXX11_FLAG)
  IF(HAS_GNU_CXX11_FLAG)
    SET(CXX_11_FLAG "-std=c++11")
  ELSE(HAS_GNU_CXX11_FLAG)
    CHECK_CXX_COMPILER_FLAG("-std=c++0x" HAS_GNU_CXX0X_FLAG)
    IF(HAS_GNU_CXX0X_FLAG)
      SET(CXX_11_FLAG "-std=c++0x")
    ELSE(HAS_GNU_CXX0X_FLAG)
      MESSAGE(WARNING "Don't know how to enable C++11, if you are lucky, they are enabled by default")
    ENDIF(HAS_GNU_CXX0X_FLAG)
  ENDIF(HAS_GNU_CXX11_FLAG)
  
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}  ${CXX_11_FLAG}")
ENDIF(UNIX)

INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/cmake/checkCpp0xAuto.cmake)
INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/cmake/checkCpp0xLambda.cmake)
INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/cmake/checkSSEAttributeVectorCanUseSubscript.cmake)


IF(NOT "${CXX_HAS_CXX_0X_AUTO}" OR NOT CXX_HAS_CXX_0X_LAMBDA)
  MESSAGE(FATAL_ERROR 
    "This source code requires the C++0x auto type and lambda features. "
    "If your compiler is supposed to support this feature, "
    "please enable the appropriate flags and delete the CMakeCache.txt file before "
    "re-running cmake.\n"
    "For g++ >= 4.6 this is '-std=c++0x' ")
ENDIF(NOT "${CXX_HAS_CXX_0X_AUTO}" OR NOT CXX_HAS_CXX_0X_LAMBDA)

INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/cmake/checkAltivecEnabled.cmake)
INCLUDE (${CMAKE_CURRENT_SOURCE_DIR}/cmake/checkSSEEnabled.cmake)

ASSERT_SIZE(char 1)
ASSERT_SIZE(short 2)
ASSERT_SIZE(int 4)
ASSERT_SIZE(float 4)
ASSERT_SIZE(double 8)

CHECK_TYPE_SIZE(long LONG_TYPE_SIZE)


IF (${LONG_TYPE_SIZE} EQUAL 8)
  SET(LONG_64BIT TRUE)
ELSE(${LONG_TYPE_SIZE} EQUAL 8)
  SET(LONG_64BIT FALSE)
ENDIF(${LONG_TYPE_SIZE} EQUAL 8)

TEST_BIG_ENDIAN(WORDS_BIGENDIAN)
CHECK_INCLUDE_FILES (unistd.h HAVE_UNISTD_H)
CHECK_INCLUDE_FILES (sys/ioctl.h HAVE_SYS_IOCTL_H)

# find additional packages
#
# With MSVC using pre-installed dynamic libraries is usually a pain because of
# the incompatibilities in the compiler flags
#
IF (MSVC)
  SET(SEARCH_LIBS_DEFAULT FALSE)
ELSE(MSVC)
  SET(SEARCH_LIBS_DEFAULT TRUE)
ENDIF (MSVC)


# Taken from ITK:
# On Visual Studio 8 MS deprecated C. This removes all 1.276E1265 security
# warnings
IF(MSVC)
  ADD_DEFINITIONS(
    -D_CRT_FAR_MAPPINGS_NO_DEPRECATE
    -D_CRT_IS_WCTYPE_NO_DEPRECATE
    -D_CRT_MANAGED_FP_NO_DEPRECATE
    -D_CRT_NONSTDC_NO_DEPRECATE
    -D_CRT_SECURE_NO_DEPRECATE
    -D_CRT_SECURE_NO_DEPRECATE_GLOBALS
    -D_CRT_SETERRORMODE_BEEP_SLEEP_NO_DEPRECATE
    -D_CRT_TIME_FUNCTIONS_NO_DEPRECATE
    -D_CRT_VCCLRIT_NO_DEPRECATE
    -D_SCL_SECURE_NO_DEPRECATE
    -D_SECURE_SCL=0
    )
ENDIF(MSVC)

SET(SOURCE_ROOT "${CMAKE_CURRENT_SOURCE_DIR}")
SET(BUILD_ROOT "${CMAKE_CURRENT_BINARY_DIR}")
SET(LIB_ROOT_INSTALL_PATH "${CMAKE_INSTALL_FULL_LIBDIR}/${MIA_NAME}")
SET(CONFIG_INSTALL_PATH "${LIB_ROOT_INSTALL_PATH}/config")
SET(LIB_INCLUDE_INSTALL_PATH "${LIB_ROOT_INSTALL_PATH}/include")
SET(PLUGIN_INSTALL_PATH "${LIB_ROOT_INSTALL_PATH}/plugins")
SET(PLUGIN_SEARCH_PATH "${PLUGIN_INSTALL_PATH}")
SET(DOC_INSTALL_PATH "share/doc/${MIA_NAME}")
SET(FULL_DOC_INSTALL_PATH "${CMAKE_INSTALL_PREFIX}/${DOC_INSTALL_PATH}")
SET(BINARY_INSTALL_PATH "${CMAKE_INSTALL_BINDIR}")
SET(LIBRARY_INSTALL_PATH "${CMAKE_INSTALL_LIBDIR}")
SET(INCLUDE_INSTALL_PATH "${CMAKE_INSTALL_INCLUDEDIR}/${MIA_NAME}")


######################################################################################
#
# Handle BOOST
#
#
MACRO(GET_BOOST_LINKERFLAG VAR LIBNAMES)
  FOREACH(L  ${LIBNAMES})
    STRING(REGEX MATCH "boost_[-_a-z0-9]*" temp ${L})
    STRING(LENGTH "${temp}" TEMP_LENGTH)
    IF(${TEMP_LENGTH})
      SET(flags "${flags} -l${temp}")
    ENDIF(${TEMP_LENGTH})
  ENDFOREACH(L  ${LIBNAMES})
  
  SET(${VAR} "${flags}")
ENDMACRO(GET_BOOST_LINKERFLAG)

SET(BOOST_COMPONENTS   filesystem  regex unit_test_framework serialization system)
IF (WIN32)
  SET(BOOST_COMPONENTS  ${BOOST_COMPONENTS} date_time)
ENDIF(WIN32)

FIND_PACKAGE( Boost 1.46.1 COMPONENTS
  ${BOOST_COMPONENTS}
  REQUIRED)

INCLUDE_DIRECTORIES(${Boost_INCLUDE_DIR})
LINK_DIRECTORIES(${Boost_LIBRARY_DIRS})

ADD_DEFINITIONS(-DBOOST_ALL_DYN_LINK)
ADD_DEFINITIONS(-DBOOST_FILESYSTEM_VERSION=3)

SET(BOOST_DEPS  ${Boost_REGEX_LIBRARY}  ${Boost_FILESYSTEM_LIBRARY} ${Boost_SYSTEM_LIBRARY})
SET(BOOST_UNITTEST  ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY})

IF (WIN32 AND NOT UNIX)
   FOREACH(l 
       ${Boost_REGEX_LIBRARIES}
       ${Boost_FILESYSTEM_LIBRARY}
       ${Boost_SYSTEM}
       ${Boost_DATE_TIME}
       )
      STRING(REGEX MATCH "lib$" head ${l})
      STRING(COMPARE EQUAL "xlib" "x${head}" islib)
      IF (${islib})
	  STRING(REGEX REPLACE "lib$" "dll" lDLL ${l})
	  INSTALL(FILES ${lDLL} DESTINATION "bin")
      ENDIF(${islib})
   ENDFOREACH(l)
ENDIF (WIN32 AND NOT UNIX)

IF (MSYS OR MINGW)
  SET(BASELIBS ${BOOST_DEPS})
ENDIF (MSYS OR MINGW)

#
# end BOOST 
#
################################################################################

################################################################################
#
# Intel Threading Building Blocks 
# 
FIND_PACKAGE(TBB REQUIRED)
IF(TBB_FOUND) 
  include_directories(${TBB_INCLUDE_DIRS})
  link_directories(${TBB_LIBRARY_DIRS})
ELSE(TBB_FOUND) 
  MESSAGE(FATAL " TBB not found")
ENDIF(TBB_FOUND)
#
# End Intel Threading Building Blocks 
#
################################################################################

################################################################################
#
# Intel Threading Building Blocks 
# 

SET(CMAKE_THREAD_PREFER_PTHREAD ON) 
FIND_PACKAGE(Threads)

IF(CMAKE_USE_PTHREADS_INIT)
  set(PTHREADLIB -lpthread)
ENDIF(CMAKE_USE_PTHREADS_INIT)

################################################################################
# 
# Handle the GNU Scientific Library, this might be a showstopper 
# on MS windows when using Visual C++ 
#
PKG_CHECK_MODULES(GSL REQUIRED gsl)
INCLUDE_DIRECTORIES(${GSL_INCLUDE_DIRS})
LINK_DIRECTORIES(${GSL_LIBRARY_DIRS})


PKG_CHECK_MODULES(EIGEN3 REQUIRED eigen3)
INCLUDE_DIRECTORIES(${EIGEN3_INCLUDE_DIRS})
LINK_DIRECTORIES(${EIGEN3_LIBRARY_DIRS})


################################################################################
# 
# search for some blas
# 

FIND_PACKAGE(BLAS)
IF (NOT BLAS_LIBRARIES) 
  MESSAGE(FATAL_ERROR "A library that implements the BLAS interface is required") 
ENDIF(NOT BLAS_LIBRARIES) 

IF(UNIX)
  GET_BOOST_LINKERFLAG(BOOST_LIBFLAG "${BOOST_DEPS}")
  SET(MIA_DEPEND_LIBRARIES "${BOOST_LIBFLAG} ${BLAS_LIBRARIES} ${TBB_LIBRARIES} ${PTHREADLIB} -ldl")
ENDIF(UNIX)


ADD_DEFINITIONS(-DHAVE_BLAS)
#
# End BLAS 
# 
##################################################################################

##################################################################################
#
# Find gzip for man page compression 
#
find_program(GZIP gzip)
IF(NOT GZIP) 
  MESSAGE(gzip not found, man pages will not be compressed)
ENDIF(NOT GZIP) 

##################################################################################
#
# take care of modules loading infrastructure
#
IF(NOT WIN32)

  FIND_LIBRARY(DL dl
    PATH
    /lib
    /usr/lib
    /opt/local/lib
    /sw/lib
  )
  IF(DL_NOTFOUND)
    MESSAGE(FATAL_ERROR "non-windows systems without libdl.so are not yet supported")
  ENDIF(DL_NOTFOUND)
  SET(BASELIBS  ${BOOST_DEPS} ${PTHREADLIB} ${DL})
ENDIF(NOT WIN32)
SET(PLUGSUFFIX ".mia")

OPTION(WARN_MISSING_OR_OLD_PLUGINTESTS "Warn if plugins don't provided tests or use the old buildsystem to do so" OFF)
#
#
#
##################################################################################

##################################################################################
#
# FFTW related tests 
#
pkg_check_modules(FFTWF REQUIRED fftw3f)
IF(FFTWF_FOUND)
    INCLUDE_DIRECTORIES(${FFTWF_INCLUDE_DIRS})
    LINK_DIRECTORIES(${FFTWF_LIBRARY_DIRS})
    SET(PKG_CONFIG_DEPS "${PKG_CONFIG_DEPS} fftw3f")
ENDIF(FFTWF_FOUND)

MARK_AS_ADVANCED(WITH_FFTWD)
OPTION(WITH_FFTWD "Use double precision FFTW if found" ON)

IF(WITH_FFTWD)
  pkg_check_modules(FFTWD fftw3 REQUIRED)
  IF(FFTWD_FOUND)
    INCLUDE_DIRECTORIES(${FFTWD_INCLUDE_DIRS})
    LINK_DIRECTORIES(${FFTWD_LIBRARY_DIRS})
    SET(PKG_CONFIG_DEPS "${PKG_CONFIG_DEPS} fftw3")
  ENDIF(FFTWD_FOUND)
ENDIF(WITH_FFTWD)
#
#
####################################################################################

####################################################################################
#
# add xml library for loading/storing segmentations and document creation  
#
pkg_check_modules(XMLPP libxml++-2.6 REQUIRED)
IF (XMLPP_FOUND)
  INCLUDE_DIRECTORIES(${XMLPP_INCLUDE_DIRS})
  LINK_DIRECTORIES(${XMLPP_LIBRARY_DIRS})
  SET(PKG_CONFIG_DEPS "${PKG_CONFIG_DEPS} libxml++-2.6")
  SET(HAVE_LIBXMLPP 1)
ENDIF (XMLPP_FOUND)

#
# end XML 
# 
###################################################################################

###################################################################################
#
# Look for IT++ for FastICA
#
OPTION(WITH_ITPP "Use IT++ for some additional features" ${SEARCH_LIBS_DEFAULT})
IF(WITH_ITPP)
  
  IF (STRICT_DEPENDECIES)
    pkg_check_modules(ITPP itpp REQUIRED)
  ELSE (STRICT_DEPENDECIES)
    pkg_check_modules(ITPP itpp)
  ENDIF(STRICT_DEPENDECIES)
  
  IF(ITPP_FOUND)
    INCLUDE_DIRECTORIES(${ITPP_INCLUDE_DIRS})
    LINK_DIRECTORIES(${ITPP_LIBRARY_DIRS})
    SET(PKG_CONFIG_DEPS "${PKG_CONFIG_DEPS} itpp")
    SET(CMAKE_REQUIRED_LIBRARIES ${ITPP_LIBRARIES})
    #if ITPP was found check if it supports the return value in separate

=== gsl++/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2014 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

SET(GSLPP_SOURCE 
  matrix.cc
  multimin.cc
  vector.cc
  wavelet.cc
  )

SET(GSLPP_HEADERS 
  matrix.hh
  multimin.hh
  vector.hh
  vector_template.hh
  wavelet.hh
  gsldefines.hh
  )

MIA_ADD_LIBRARY(miagsl "${GSLPP_SOURCE}" "${GSL_LIBRARIES}" "${BLAS_LIBRARIES}")

INSTALL_WITH_EXPORT(miagsl)

INSTALL(FILES ${GSLPP_HEADERS} DESTINATION "${INCLUDE_INSTALL_PATH}/gsl++")

MACRO(GSL_TEST name)
  ADD_EXECUTABLE(test-${name} test_${name}.cc)
  TARGET_LINK_LIBRARIES(test-${name} miagsl ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY})
  ADD_TEST(${name} test-${name})
ENDMACRO(GSL_TEST name)

IF(Boost_UNIT_TEST_FRAMEWORK_FOUND)
  GSL_TEST(vector)
  GSL_TEST(matrix)
  GSL_TEST(multimin)
ENDIF(Boost_UNIT_TEST_FRAMEWORK_FOUND)

=== addons/hdf5/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2014 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

OPTION(USE_HDF5 "use hdf5 for data UI" TRUE)


IF (USE_HDF5)
  if (STRICT_DEPENDECIES)
    find_package(HDF5 REQUIRED)
  else (STRICT_DEPENDECIES)
    find_package(HDF5)
  endif (STRICT_DEPENDECIES)
  
  IF(HDF5_FOUND)
    DEFINE_PROPERTY(GLOBAL PROPERTY HAVE_HDF5_PROP BRIEF_DOCS "yeah" FULL_DOCS "yeah")
    INCLUDE_DIRECTORIES(${HDF5_INCLUDE_DIRS})
    LINK_DIRECTORIES(${HDF5_LIBRARY_DIRS})
    SET(HDF5IO_SRC hdf5mia.cc hdf5a_mia.cc)
    SET(HDF5MIALIBS miacore ${HDF5_LIBRARIES})
    MIA_ADD_LIBRARY(miahdf5 "${HDF5IO_SRC}" "${HDF5MIALIBS}")
    SET(INSTALL_TARGETS miahdf5)	
    INSTALL_BASE("${INSTALL_TARGETS}")


    NEW_TEST(hdf5mia miahdf5)
    SET(DEPS3D miahdf5 mia3d)

    PLUGIN_WITH_TEST_AND_PREFIX2("3dimage" "io" hdf5_3dimage  "${DEPS3D}")

  ENDIF(HDF5_FOUND)
  
ENDIF(USE_HDF5)

=== addons/openexr/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2014 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

OPTION(WITH_OpenEXR "enable support for OpenEXR" ${SEARCH_LIBS_DEFAULT})

IF(WITH_OpenEXR)
  
  if (STRICT_DEPENDECIES)
    pkg_check_modules(EXR REQUIRED OpenEXR)
  else (STRICT_DEPENDECIES)
    pkg_check_modules(EXR OpenEXR)
  endif (STRICT_DEPENDECIES)
  
  
  IF( EXR_LIBRARIES AND EXR_INCLUDE_DIRS )
    DEFINE_PROPERTY(GLOBAL PROPERTY HAVE_OPENEXR_PROP BRIEF_DOCS "yeah" FULL_DOCS "yeah")
    SET(image2dio_path ${PLUGIN_INSTALL_PATH}/2dimage/io)
    SET(image3dio_path ${PLUGIN_INSTALL_PATH}/3dimage/io)
    SET(vf2dio_path ${PLUGIN_INSTALL_PATH}/2dvf/io)
    
    SET(EXR_LINK_LIBS ${MIA2DLIBS} ${EXR_LIBRARIES})

    LINK_DIRECTORIES(${EXR_LIBRARY_DIRS})

    SET(DEPS2D mia2d ${EXR_LIBRARIES})
    
    INCLUDE_DIRECTORIES(${EXR_INCLUDE_DIRS})
    
    PLUGIN_WITH_PREFIX2("2dimage" "io" 2dimgexr "${DEPS2D}")
    PLUGIN_WITH_PREFIX2("2dvf" "io"    2dvfexr "${DEPS2D}")
    
    # test programs 
    ADD_EXECUTABLE(test-openexr test_openexr.cc)
    ADD_DEPENDENCIES(test-openexr 2dimage-io-openexr 2dvf-io-openexr)
    
    SET(DEPLIBS mia2dtest mia2d ${BASELIBS})
    TARGET_LINK_LIBRARIES(test-openexr ${DEPLIBS} ${BOOST_UNITTEST})
    
    ADD_TEST(exr test-openexr)
    
    
  ENDIF(EXR_LIBRARIES AND EXR_INCLUDE_DIRS)
  
ENDIF(WITH_OpenEXR)

=== addons/vistaio/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2014 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

OPTION(USE_VISTAIO "use libvistaio" TRUE)


IF (USE_VISTAIO)
  if (STRICT_DEPENDECIES)
    pkg_check_modules(VISTAIO REQUIRED libvistaio>=1.2.14)
  else (STRICT_DEPENDECIES)
    pkg_check_modules(VISTAIO libvistaio>=1.2.14)
  endif (STRICT_DEPENDECIES)
  
  IF( VISTAIO_FOUND )
    DEFINE_PROPERTY(GLOBAL PROPERTY HAVE_VISTAIO_PROP BRIEF_DOCS "yeah" FULL_DOCS "yeah")
    INCLUDE_DIRECTORIES(${VISTAIO_INCLUDE_DIRS})
    LINK_DIRECTORIES(${VISTAIO_LIBRARY_DIRS})
    SET(VISTAIO_SRC vista4mia.cc)
    SET(VISTAIO4MIALIBS miacore ${VISTAIO_LIBRARIES})
    MIA_ADD_LIBRARY(vista4mia "${VISTAIO_SRC}" "${VISTAIO4MIALIBS}")
    
    SET(DEPS2D mia2d vista4mia)
    SET(DEPS3D mia3d vista4mia)
    SET(DEPSMESH miamesh vista4mia)
    

    PLUGIN_WITH_TEST_AND_PREFIX2("2dimage" "io" 2dvistaio "${DEPS2D}")
    PLUGIN_WITH_TEST_AND_PREFIX2("3dimage" "io" 3dvistaio  "${DEPS3D}")

   
    PLUGIN_WITH_PREFIX2("2dvf" "io" 2dvfvistaio "${DEPS2D}")
    PLUGIN_WITH_PREFIX2("3dvf" "io" 3dvfvistaio "${DEPS3D}")
    PLUGIN_WITH_PREFIX2("mesh" "io" vistamesh "${DEPSMESH}")
    PLUGIN_WITH_TEST_AND_PREFIX2("2dtransform" "io" 2dtrans "${DEPS2D}" TESTLIBS mia2dtest)
    PLUGIN_WITH_TEST_AND_PREFIX2("3dtransform" "io" 3dtrans "${DEPS3D}" )
    
  
    ADD_EXECUTABLE(test-vista4mia  test_vista4mia.cc)
    ADD_DEPENDENCIES(test-vista4mia  2dvistaio 3dvistaio 3dvfvistaio)
    
    SET(VISTADEPLIBS vista4mia mia3dtest mia2dtest mia3d mia2d)
    
    TARGET_LINK_LIBRARIES(test-vista4mia ${VISTADEPLIBS} ${BOOST_UNITTEST})
    
    SET(INSTALL_TARGETS vista4mia)	
    INSTALL_BASE("${INSTALL_TARGETS}")
    
    IF (WIN32)
      ADD_TEST(vista "${CMAKE_CURRENT_SOURCE_DIR}/test-vista4mia.bat")
    ELSE (WIN32)
      ADD_TEST(vista test-vista4mia)
    ENDIF(WIN32)
  
  ENDIF( VISTAIO_FOUND )
ENDIF(USE_VISTAIO)

=== addons/vtk/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2014 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

OPTION(WITH_VTKIO "enable support for VTK files" ${SEARCH_LIBS_DEFAULT})

IF(WITH_VTKIO)
  if (STRICT_DEPENDECIES)
    FIND_PACKAGE(VTK REQUIRED)
  else (STRICT_DEPENDECIES)
    FIND_PACKAGE(VTK QUIET)
  endif (STRICT_DEPENDECIES)
  IF(VTK_FOUND)
    DEFINE_PROPERTY(GLOBAL PROPERTY HAVE_VTK_PROP BRIEF_DOCS "yeah" FULL_DOCS "yeah")
    INCLUDE_DIRECTORIES(${VTK_INCLUDE_DIRS})
    SET(meshio_path ${PLUGIN_INSTALL_PATH}/mesh/io)
    SET(vfio_path "${PLUGIN_INSTALL_PATH}/3dvf/io")
    SET(imageio_path "${PLUGIN_INSTALL_PATH}/3dimage/io")
    
    SET(VTK_LINK_LIBS_MESH ${VTK_LIBRARIES} miamesh)
    SET(VTK_LINK_LIBS_3D ${VTK_LIBRARIES} mia3d)

    PLUGIN_WITH_TEST_AND_PREFIX2("mesh" "io" vtkmesh "${VTK_LINK_LIBS_MESH}")
    PLUGIN_WITH_TEST_AND_PREFIX2("3dvf" "io" vtkvf "${VTK_LINK_LIBS_3D}")
    PLUGIN_WITH_TEST_AND_PREFIX2("3dimage" "io" vtkimage "${VTK_LINK_LIBS_3D}")

  ELSEIF(VTK_FOUND)
    MESSAGE(MESSAGE "VTK not found, disabled")
  ENDIF(VTK_FOUND)
ENDIF(WITH_VTKIO)

=== mia/2d/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2014 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

SET(MIA2D_SRC_BASE
  angle.cc
  boundingbox.cc
  correlation_weight.cc 
  cost.cc
  creator.cc
  cstkernel.cc 
  datafield.cc
  distance.cc
  filter.cc
  image.cc
  imageio.cc
  interpolator.cc 
  filterchain.cc
  fftkernel.cc
  fuzzyseg.cc
  fuzzyclustersolver_sor.cc
  fuzzyclustersolver_cg.cc
  fullcost.cc
  maskedcost.cc 
  model.cc
  morphshape.cc
  multicost.cc
  nfg.cc
  nonrigidregister.cc 
  polygon.cc
  ppmatrix.cc
  rgbimageio.cc
  rigidregister.cc
  shape.cc
  similarity_profile.cc
  sparse_image_solver.cc
  splinetransformpenalty.cc
  timestep.cc
  trackpoint.cc
  transform.cc
  transformio.cc
  transformfactory.cc
  vectorfield.cc
  vfio.cc
  )


SET(SEG_SRC 
  segframe.cc 
  segpoint.cc 
  segsection.cc 
  segset.cc
  segsetwithimages.cc
  segstar.cc 
  )
SET(SEG_HEADER 
  segpoint.hh
  segstar.hh
  segsection.hh
  segframe.hh
  segset.hh
  segsetwithimages.hh
  )

IF(ITPP_FOUND)
  SET(ITPP_SRC 
    ica.cc 
    perfusion.cc
    )
  SET(ITPP_HEADER 
    ica.hh
    perfusion.hh
    )
ENDIF(ITPP_FOUND)

SET(MIA2D_SRC ${MIA2D_SRC_BASE} ${MIA2D_FFTW_CODE})

SET(MIA2D_HEADERS_BASE
  angle.hh
  datafield.hh datafield.cxx
  filter.hh
  image.hh
  imageio.hh
  imageiotest.hh
  vector.hh
  vectorfield.hh
  vfio.hh
  boundingbox.hh
  cost.hh
  correlation_weight.hh 
  creator.hh
  cstkernel.hh 
  defines2d.hh
  deformer.hh
  distance.hh
  fullcost.hh
  filterchain.hh
  fftkernel.hh
  fuzzyseg.hh
  fuzzyclustersolver_sor.hh
  fuzzyclustersolver_cg.hh
  ground_truth_evaluator.hh
  groundtruthproblem.hh
  interpolator.hh
  iterator.hh
  iterator.cxx
  matrix.hh
  maskedcost.hh 
  model.hh
  morphshape.hh
  multicost.hh
  nonrigidregister.hh
  nfg.hh
  perfusion.hh
  polygon.hh
  ppmatrix.hh
  rgbimageio.hh
  rigidregister.hh
  shape.hh
  similarity_profile.hh
  sparse_image_solver.hh
  splinetransformpenalty.hh
  timestep.hh
  trait.hh
  trackpoint.hh
  transform.hh
  transformmock.hh
  transformio.hh
  transformfactory.hh
  interpolator.hh interpolator.cxx
  )

SET(MIA2D_HEADERS ${MIA2D_HEADERS_BASE} ${SEG_HEADER} ${ITPP_HEADER})

#
# the main 2D library
# 
MIA_ADD_LIBRARY(mia2d "${MIA2D_SRC}" miacore)

#
# What we need to link from here on 
#
SET(MIA2DLIBS mia2d  ${LIBS})


#
# The test library: On MS windows it needs to be static, 
# because it doesen't resolve all
# symbols, and in Windows, this is not supported# 
SET(mia2dtestsrc 
  imageiotest.cc 
  vfiotest.cc 
  imagetest.cc
  transformmock.cc
  )
SET(mia2dlibdeps mia2d ${BOOST_UNITTEST})

MIA_ADD_LIBRARY(mia2dtest "${mia2dtestsrc}" "${mia2dlibdeps}")
SET_TARGET_PROPERTIES(mia2dtest PROPERTIES COMPILE_FLAGS -DBOOST_TEST_DYN_LINK)


IF(APPLE)
   SET_TARGET_PROPERTIES(mia2dtest PROPERTIES LINK_FLAGS "-single_module -Wl,-flat_namespace -Wl,-undefined -Wl,suppress")
ENDIF(APPLE)

MACRO(TEST_2DMIA file libs)
  ADD_EXECUTABLE(test-2d-${file} test_${file}.cc)
  TARGET_LINK_LIBRARIES(test-2d-${file} ${libs} ${BOOST_UNITTEST} )
  ADD_TEST(2d-${file} test-2d-${file})
ENDMACRO(TEST_2DMIA file)

TEST_2DMIA(angle mia2d)
TEST_2DMIA(datafield mia2dtest)
TEST_2DMIA(image mia2dtest)
TEST_2DMIA(filter mia2dtest)
TEST_2DMIA(param mia2dtest)
TEST_2DMIA(vector mia2dtest)
TEST_2DMIA(boundingbox mia2dtest)
TEST_2DMIA(distance mia2dtest)
TEST_2DMIA(fullcost mia2dtest)
TEST_2DMIA(interpol mia2dtest)
TEST_2DMIA(matrix mia2dtest)
TEST_2DMIA(nfg mia2dtest)
TEST_2DMIA(cost mia2dtest)
TEST_2DMIA(iterator mia2dtest)
TEST_2DMIA(nonrigidregister mia2dtest)
TEST_2DMIA(oldnewintegrate mia2dtest)
TEST_2DMIA(combiner mia2dtest)
TEST_2DMIA(polygon mia2dtest)
TEST_2DMIA(ppmatrix mia2dtest)
TEST_2DMIA(rigidregister mia2dtest)
TEST_2DMIA(transformfactory mia2dtest)
TEST_2DMIA(vectorfield_interpolator mia2dtest)
TEST_2DMIA(similarity_profile mia2dtest)
TEST_2DMIA(transio mia2d)
TEST_2DMIA(transform mia2dtest)
TEST_2DMIA(shape mia2dtest)
TEST_2DMIA(morphshape mia2dtest)
TEST_2DMIA(imageio mia2dtest)
TEST_2DMIA(sparse_image_solver mia2dtest)
TEST_2DMIA(filter_cast mia2d)
TEST_2DMIA(splinetransformpenalty mia2d)
TEST_2DMIA(trackpoint mia2dtest)

IF(CMAKE_BUILD_TYPE)
  SET(CONFIG ${CMAKE_BUILD_TYPE})
ELSE(CMAKE_BUILD_TYPE)
  SET(CONFIG "NOCONFIG")
ENDIF(CMAKE_BUILD_TYPE)

#
# installation 
#
INSTALL_WITH_EXPORT(mia2d)
INSTALL_WITH_EXPORT(mia2dtest)

INSTALL(FILES ${MIA2D_HEADERS} DESTINATION ${INCLUDE_INSTALL_PATH}/mia/2d)



SET(MIA2D_MYOCARDPERF_SRC 
  ${SEG_SRC}
  ${ITPP_SRC}
  ground_truth_evaluator.cc
  groundtruthproblem.cc

)  

SET(MIA2D_MYOCARDPERF_HEADER 
  ${SEG_HEADER}
  ${ITPP_HEADER}
  ground_truth_evaluator.hh
  groundtruthproblem.hh
)  

MIA_ADD_LIBRARY(mia2dmyocardperf "${MIA2D_MYOCARDPERF_SRC}" mia2d)

INSTALL_WITH_EXPORT(mia2dmyocardperf)
INSTALL(FILES ${MIA2D_MYOCARDPERF_HEADER} DESTINATION ${INCLUDE_INSTALL_PATH}/mia/2d)

IF(ITPP_FOUND)
  TEST_2DMIA(ica mia2dmyocardperf)
  TEST_2DMIA(perfusion mia2dmyocardperf)
ENDIF(ITPP_FOUND)

set(testperflibs mia2dmyocardperf mia2dtest)

TEST_2DMIA(groundtruthproblem mia2dmyocardperf)
TEST_2DMIA(correlation_weight mia2dmyocardperf)
TEST_2DMIA(segmentation mia2dmyocardperf)
TEST_2DMIA(segframe "${testperflibs}")
TEST_2DMIA(segpoint mia2dmyocardperf)


#
# The plugin directories 
#
ADD_SUBDIRECTORY(cost      )
ADD_SUBDIRECTORY(combiner  )
ADD_SUBDIRECTORY(creator   )
ADD_SUBDIRECTORY(io        )
ADD_SUBDIRECTORY(filter    )
ADD_SUBDIRECTORY(fft       )
ADD_SUBDIRECTORY(fullcost  )
ADD_SUBDIRECTORY(kernel    )
ADD_SUBDIRECTORY(model     )
ADD_SUBDIRECTORY(maskedcost)
ADD_SUBDIRECTORY(rgbio     )
ADD_SUBDIRECTORY(shapes    )
#ADD_SUBDIRECTORY(sparseimgsolver )
ADD_SUBDIRECTORY(timestep  )
ADD_SUBDIRECTORY(transform )
ADD_SUBDIRECTORY(transio )
ADD_SUBDIRECTORY(splinepenalty )

=== mia/core/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2014 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

SET(MIACORE_SRC_BASE 
  attributes.cc 
  attribute_names.cc 
  boundary_conditions.cc
  callback.cc 
  cost.cc 
  combiner.cc
  cmdlineparser.cc
  cmdoption.cc
  cmdstringoption.cc
  cmdbooloption.cc
  creator.cc
  datapool.cc
  distance.cc
  dlloader.cc
  dummyhandler.cc
  file.cc 
  filetools.cc 
  filter.cc
  fixedwidthoutput.cc
  fft1d_r2c.cc 
  fftslopeclassifier.cc
  flagstring.cc
  fullstats.cc
  handlerbase.cc
  history.cc
  index.cc
  info.cc
  splinekernel.cc
  interpolator1d.cc
  iodata.cc
  ioplugin.cc
  labelmap.cc
  mitestimages.cc
  module.cc
  msgstream.cc 
  minimizer.cc
  nccsum.cc 
  noisegen.cc 
  optionparser.cc 
  optparam.cc 
  paramoption.cc  
  parameter.cc  
  pixeltype.cc 
  plugin_base.cc  
  product_base.cc
  productcache.cc
  property_flags.cc
  probmap.cc
  regmodel.cc
  revision.cc 
  scaler1d.cc
  seriesstats.cc 
  shape.cc 
  slopestatistics.cc
  slopeclassifier.cc
  spacial_kernel.cc 
  splineparzenmi.cc
  sqmin.cc
  streamredir.cc
  testplugin.cc 
  threadedmsg.cc
  typedescr.cc
  utils.cc 
  watch.cc 
  waveletslopeclassifier.cc
  )

SET(MIACORE_HEADER_BASE
  attributes.hh
  attribute_names.hh 
  attributetype.hh
  boundary_conditions.hh
  bfsv23dispatch.hh
  callback.hh
  cmdbooloption.hh
  cmdlineparser.hh
  cmdoption.hh
  cmdoptionflags.hh
  cmdstringoption.hh
  combiner.hh
  cost.hh
  cost.cxx
  combiner.hh
  creator.hh
  cstplan.hh
  datapool.hh
  defines.hh
  delayedparameter.hh
  dictmap.hh
  distance.hh
  dlloader.hh
  dummyhandler.hh
  errormacro.hh
  export_handler.hh
  factory.hh
  factory_trait.hh
  fft1d_r2c.hh
  fftslopeclassifier.hh
  fifofilter.hh
  file.hh
  filetools.hh
  filter.hh
  fixedwidthoutput.hh
  flagstring.hh
  fullstats.hh
  handlerbase.hh
  handler.cxx handler.hh
  history.hh
  histogram.hh
  index.hh
  import_handler.hh
  iodata.hh
  iohandler.cxx iohandler.hh
  ioplugin.cxx ioplugin.hh
  kmeans.hh
  labelmap.hh
  meanvar.hh
  mitestimages.hh
  module.hh
  msgstream.hh
  minimizer.hh
  noisegen.hh
  nccsum.hh
  optionparser.hh
  optparam.hh
  parameter.cxx parameter.hh
  paramoption.hh
  pixeltype.hh
  plugin_base.cxx plugin_base.hh
  probmap.hh
  property_flags.hh
  product_base.hh
  productcache.hh
  refholder.hh
  regmodel.hh
  scaler1d.hh
  shape.hh shape.cxx
  seriesstats.hh
  singular_refobj.hh
  slopestatistics.hh
  slopeclassifier.hh
  slopevector.hh
  splinekernel.hh
  splineparzenmi.hh
  spacial_kernel.hh
  sparse_solver.hh
  sqmin.hh
  statistics.hh
  streamredir.hh
  svector.hh
  testplugin.hh
  threadedmsg.hh
  tools.hh
  traits.hh
  transformation.hh
  typedescr.hh
  type_traits.hh
  utils.hh
  vector.hh
  watch.hh
  waveletslopeclassifier.hh
  )

SET(MIACORETEST_SRC 
  test_core.cc
  test_cost.cc
  test_filter.cc
  test_kernels.cc
  test_optparam.cc
  test_optionparser.cc
  test_parameter.cc
  test_pixeltype.cc
  test_register.cc
  test_sqmin.cc
  test_streamredir.cc
  test_dictmap.cc
  test_fifofilter.cc
  test_probmap.cc
)

IF(ITPP_FOUND)
  SET(ITPP_SRC 
    ica.cc 
    )
  SET(ITPP_HEADER 
    ica.hh
    ica_template.hh ica_template.cxx
    )
ENDIF(ITPP_FOUND)

IF(PWPDF_FOUND) 
  SET(PWPDF_SRC 
    pwh.cc
    )
  SET(PWPDF_HEADER 
    pwh.hh
    )
ENDIF(PWPDF_FOUND) 

MACRO(CORE_TEST name)
  ADD_EXECUTABLE(test-${name} test_${name}.cc)  
  TARGET_LINK_LIBRARIES(test-${name} ${MIACORE} ${BOOST_UNITTEST})
  ADD_TEST(core-${name} test-${name})
  IF(WIN32)
    SET_TARGET_PROPERTIES(test-${name} PROPERTIES LINKER_FLAGS "/NODEFAULTLIB:MSVCRT")
  ENDIF(WIN32)
ENDMACRO(CORE_TEST name)

#
# create the revision retrival code
#
CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/revision.hh.cmake ${CMAKE_CURRENT_BINARY_DIR}/revision.hh)


#
# the library target 
#
SET(MIACORE_SRC ${MIACORE_SRC_BASE} ${ITPP_SRC} ${FFTWF_SRC} ${PWPDF_SRC})
SET(MIACORE_HEADER ${MIACORE_HEADER_BASE} ${ITPP_HEADER} ${FFTWF_HEADER} ${PWPDF_HEADER})

SET(miacore_deps miagsl ${BASELIBS} ${TBB_LIBRARIES} ${FFTWF_LIBRARIES} ${XMLPP_LIBRARIES})
MIA_ADD_LIBRARY(miacore "${MIACORE_SRC}" "${miacore_deps}")
ADD_DEPENDENCIES(miacore revision.hh)

IF(PWPDF_FOUND AND FFTWD_FOUND)
  TARGET_LINK_LIBRARIES(miacore ${PWPDF_LIBRARIES})
ENDIF(PWPDF_FOUND AND FFTWD_FOUND)

IF(ITPP_FOUND)
  TARGET_LINK_LIBRARIES(miacore ${ITPP_LIBRARIES})
ENDIF(ITPP_FOUND)

SET(MIACORE miacore ${BASELIBS})
SET_TARGET_PROPERTIES(miacore PROPERTIES 
  SOVERSION ${LIBRARY_SOVERSION_INFO}
  VERSION ${LIBRARY_VERSION_INFO}
)



#
# the test targets 
#

ADD_EXECUTABLE(test-core ${MIACORETEST_SRC})
ADD_TEST(core test-core)

TARGET_LINK_LIBRARIES(test-core ${MIACORE} ${BOOST_UNITTEST})

IF(WIN32)
  SET_TARGET_PROPERTIES(test-core PROPERTIES LINKER_FLAGS "/NODEFAULTLIB:MSVCRT")
ENDIF(WIN32)

#IF (NOT WIN32)
#  CORE_TEST(history)
#ENDIF (NOT WIN32)
#CORE_TEST(noisegen)

ADD_SUBDIRECTORY(testplug      )
ADD_SUBDIRECTORY(spacialkernel )
ADD_SUBDIRECTORY(noise         ) 
ADD_SUBDIRECTORY(minimizer     ) 
ADD_SUBDIRECTORY(splinekernel  ) 
ADD_SUBDIRECTORY(splinebc  ) 

NEW_TEST(Vector miacore)
NEW_TEST(attributes miacore)
NEW_TEST(boundary_conditions  miacore)
NEW_TEST(callback miacore)
NEW_TEST(cmdoptionflags miacore)
NEW_TEST(cmdlineparser miacore)
NEW_TEST(datapool miacore)
NEW_TEST(delayedparameter miacore)
NEW_TEST(distance miacore)
NEW_TEST(factoryoption miacore)
NEW_TEST(fftslopeclassifier miacore)
NEW_TEST(filetools miacore)
NEW_TEST(fixedwidthoutput miacore)
NEW_TEST(flagstring  miacore)
NEW_TEST(fullstats miacore)
NEW_TEST(handler miacore)
NEW_TEST(histogram miacore)
NEW_TEST(index miacore)
NEW_TEST(interpolator1d miacore)
NEW_TEST(iohandler miacore)
NEW_TEST(kmeans miacore)
NEW_TEST(labelmap miacore)
NEW_TEST(meanvar  miacore)
NEW_TEST(nccsum  miacore)
NEW_TEST(productcache  miacore)
NEW_TEST(property_flags  miacore)
NEW_TEST(scaler1d miacore)
NEW_TEST(seriesstats miacore)
NEW_TEST(singular_refobj miacore)
NEW_TEST(shape miacore)
NEW_TEST(simpson miacore)
NEW_TEST(slopeclassifier miacore)
NEW_TEST(slopestatistics miacore)
NEW_TEST(sparse_solver miacore)
NEW_TEST(splinekernel miacore)
NEW_TEST(splineparzenmi miacore)
NEW_TEST(streamvector miacore)
NEW_TEST(statistics miacore)
NEW_TEST(threadedmsg miacore)
NEW_TEST(tools miacore)
NEW_TEST(utils miacore)
#NEW_TEST(watch miacore)
NEW_TEST(waveletslopeclassifier miacore)

IF(ITPP_FOUND)
  NEW_TEST(ica miacore)
ENDIF(ITPP_FOUND)

IF(FFTWF_FOUND AND WITH_FFTWF)
  NEW_TEST(fft1d miacore)
ENDIF(FFTWF_FOUND AND WITH_FFTWF)

IF(PWPDF_FOUND) 
  NEW_TEST(pwh miacore)
ENDIF(PWPDF_FOUND) 
#
#installation 
#

INSTALL_WITH_EXPORT(miacore)
INSTALL(FILES ${MIACORE_HEADER} DESTINATION ${INCLUDE_INSTALL_PATH}/mia/core)

=== mia/mesh/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2014 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

SET(MIAMESH_SRC
  triangularMesh.cc
  filter.cc
) 

SET(MIAMESH_HEADERS
  triangularMesh.hh
  triangulate.hh
  filter.hh
  clist.hh
)

MIA_ADD_LIBRARY(miamesh "${MIAMESH_SRC}" mia3d)

MACRO(TEST_MESH name)
  ADD_EXECUTABLE(test-${name} test_${name}.cc)  
  TARGET_LINK_LIBRARIES(test-${name} miamesh ${BOOST_UNITTEST})
  ADD_TEST(${name} test-${name})
  IF(WIN32)
    SET_TARGET_PROPERTIES(test-${name} PROPERTIES LINKER_FLAGS "/NODEFAULTLIB:MSVCRT")
  ENDIF(WIN32)
ENDMACRO(TEST_MESH name)

SET(INSTALL_MESH miamesh)	
INSTALL_WITH_EXPORT("${INSTALL_MESH}")
INSTALL(FILES ${MIAMESH_HEADERS} DESTINATION ${INCLUDE_INSTALL_PATH}/mia/mesh)

SET(MIAMESHLIBS miamesh)

ADD_SUBDIRECTORY(io)
ADD_SUBDIRECTORY(filter)


TEST_MESH(triangulate)

=== src/isosurface/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2014 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

SET(miagts_SOURCES 
  iso_backend.cc  mesh_convert.cc
  )

OPTION(WITH_GTS "Use the GNU Triangulated Surfaces Library for some mesh realted features" ${SEARCH_LIBS_DEFAULT})

IF(WITH_GTS) 
  IF(STRICT_DEPENDECIES) 
    pkg_check_modules(GTS gts REQUIRED)
  ELSE(STRICT_DEPENDECIES) 
    pkg_check_modules(GTS gts REQUIRED)
  ENDIF(STRICT_DEPENDECIES) 
ENDIF(WITH_GTS) 

IF(GTS_FOUND) 
  INCLUDE_DIRECTORIES(${GTS_INCLUDE_DIRS})
  set( miagts_DEPS miamesh ${GTS_LIBRARIES})
  MIA_ADD_LIBRARY(miagts "${miagts_SOURCES}" "${miagts_DEPS}")
  INSTALL_WITH_EXPORT(miagts)

  # add the ISO-surface programs 
  ADD_EXECUTABLE(mia-3disosurface-from-volume iso.cc)
  CREATE_EXE_DOCU(3disosurface-from-volume)
  TARGET_LINK_LIBRARIES(mia-3disosurface-from-volume miagts)
  INSTALL(TARGETS mia-3disosurface-from-volume RUNTIME DESTINATION "bin")

  ADD_EXECUTABLE(mia-3disosurface-from-stack iso_from_slices.cc)
  CREATE_EXE_DOCU(3disosurface-from-stack)
  TARGET_LINK_LIBRARIES(mia-3disosurface-from-stack miagts)
  INSTALL(TARGETS mia-3disosurface-from-stack RUNTIME DESTINATION "bin")

  # add GTS IO plug-in
  
  
ENDIF(GTS_FOUND)

=== mia/2d/combiner/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2014 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

SET(combiners
  ops)

PLUGINGROUP_WITH_TEST_AND_PREFIX2("2dimage" "combiner" "${combiners}" "${MIA2DLIBS}")

=== mia/2d/rgbio/CMakeLists.txt ===
#
# This file is part of MIA - a toolbox for medical image analysis 
# Copyright (c) Leipzig, Madrid 1999-2014 Gert Wollny
#
# MIA is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, see <http://www.gnu.org/licenses/>.
#

PLUGIN_WITH_PREFIX2("rgbimage" "io" bmp "${MIA2DLIBS}" )

IF (FALSE)
IF(TIFF_FOUND)
  SET(TIFF_LINK_LIBS ${MIA2DLIBS} ${TIFF_LIBRARIES})
  PLUGIN_WITH_PREFIX2("rgbimage" "io" tiff "${TIFF_LINK_LIBS}" )
  INCLUDE_DIRECTORIES(${TIFF_INCLUDE_DIR})
ENDIF(TIFF_FOUND)

ENDIF(FALSE)

=== debian/changelog ===
mia (2.2.0-1) unstable; urgency=medium

  * New upstream release
  * Change library and devel packages from 2.0 to 2.2 because of 
    ABI and API changes
  * Tighten dependency on BOOST packages
  * Add dependency on libeigen3-dev, libhdf5-dev, and libnifti-dev
  * Transition libvtk6-dev
  * Add patch 02_float_test_close_powerpc_accuracy.patch to 
    correct test on powerpc 
  * Fix typos in control file, Closes: #743801, Closes: #743802
  * Add libmia-2.2-doc replaces/breaks libmia-2.0-doc

 -- Gert Wollny <gw.fossdev@gmail.com>  Tue, 02 Sep 2014 15:23:04 +0200

=== debian/control ===
Source: mia
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Gert Wollny <gw.fossdev@gmail.com>
Section: science
Priority: optional
Build-Depends: cmake (>= 2.8.8),
               debhelper (>= 9.0.0),
               docbook-xsl,
               doxygen,
               libblas-dev,
               libboost-filesystem-dev (>= 1.46.1),
               libboost-regex-dev (>= 1.46.1),
               libboost-serialization-dev (>= 1.46.1),
               libboost-system-dev (>= 1.46.1),
               libboost-test-dev (>= 1.46.1),
               libdcmtk2-dev,
               libeigen3-dev, 
               libfftw3-dev,
               libgsl0-dev (>= 1.14),
               libgts-dev,
               libhdf5-dev, 
               libitpp-dev (>= 4.2),
               libnifti-dev, 
               libnlopt-dev (>= 2.3),
               libopenexr-dev (>= 1.6.1),
               libpng-dev,
               libtbb-dev (>= 3.0),
               libtiff-dev,
               libvtk6-dev,
               libvistaio-dev (>=1.2.12),
               libxml++2.6-dev (>= 2.34.1),
               python-lxml,
               xsltproc
Standards-Version: 3.9.5
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-med/mia.git
Vcs-Git: git://anonscm.debian.org/debian-med/mia.git
Homepage: http://mia.sourceforge.net

Package: libmia-2.2-dev
Architecture: any
Section: libdevel
Depends: libmia-2.2-0 (= ${binary:Version}),
         libxml++2.6-dev (>= 2.34.1),
         libeigen3-dev, 
         libitpp-dev (>= 4.2),
         libtbb-dev,
         libgsl0-dev,
         libboost-filesystem-dev (>= 1.46.1),
         libboost-regex-dev (>= 1.46.1),
         libboost-serialization-dev (>= 1.46.1),
         libboost-system-dev (>= 1.46.1),
         libboost-test-dev (>= 1.46.1),
         libfftw3-dev,
         libblas-dev,
         ${misc:Depends}
Recommends: libmia-2.2-doc
Description: library for 2D and 3D gray scale image processing, development files
 libmia comprises a set of libraries and plug-ins for general purpose 
 2D and 3D gray scale image processing and basic handling of triangular 
 meshes. The libraries provide a basic infrastructure and  generic 
 algorithms, that can be specialized by specifying the apropriate plug-ins. 
 This package provides the development files for the library.

Package: libmia-2.2-doc
Architecture: all
Section: doc
Depends: ${misc:Depends},
         libjs-jquery
Enhances: libmia-2.2-dev
Replaces: libmia-2.0-doc
Breaks: libmia-2.0-doc
Description: library for 2D and 3D gray scale image processing, documentation
 libmia comprises a set of libraries and plug-ins for general purpose 
 2D and 3D gray scale image processing and basic handling of triangular 
 meshes. The libraries provide a basic infrastructure and  generic 
 algorithms, that can be specialized by specifying the apropriate plug-ins. 
 This package provides the Doxygen generated API reference. 

Package: libmia-2.2-0
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: library for 2D and 3D gray scale image processing
 libmia comprises a set of libraries and plug-ins for general purpose 
 2D and 3D gray scale image processing and basic handling of triangular 
 meshes. The libraries provide a basic infrastructure and  generic 
 algorithms, that can be specialized by specifying the apropriate plug-ins. 

Package: libmia-2.2-0-dbg
Architecture: any
Section: debug
Priority: extra
Depends: libmia-2.2-0 (= ${binary:Version}),
         ${misc:Depends}
Description: Debug information for the MIA library 
 libmia comprises a set of libraries and plug.ins for general purpose 
 2D and 3D gray scale image processing and basic handling of triangular 
 meshes. The libraries provide a basic infrastructure and  generic 
 algorithms, that can be specialized by specifying the apropriate plug-ins. 
 libmia is library for general purpouse 2D and 3D gray scale image processing. 
 This package provides the debug information of the library. 

Package: mia-tools
Architecture: any
Depends: libmia-2.2-0 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Recommends: mia-tools-doc
Description: Command line tools for gray scale image processing
 Command lines tools to run general purpose image processing tasks on 2D 
 and 3D gray scale images, and basic operations on triangular meshes. 
 Supported image processing algorithms are image filtering, combining, image 
 registration, motion compensation for image series, and the estimation of 
 various statistics over images. 

Package: mia-tools-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}
Enhances: mia-tools
Description: Cross-referenced documentation of the MIA command line tools
 Cross referenced documentation of the command line tools and plug-ins that 
 are provided by the MIA gray scale image processing tool chain. 
 These lines tools to provide the means to run general purpose image 
 processing tasks on 2D and 3D gray scale images, and basic operations on 
 triangular meshes interactively from the command line. Supported image 
 processing algorithms are image filtering, combining, image registration, 
 motion compensation for image series, and the estimation of various 
 statistics over images. 

Package: mia-tools-dbg
Architecture: any
Section: debug
Priority: extra
Depends: mia-tools (= ${binary:Version}),
         ${misc:Depends}
Description: Debugging information for the MIA command line tools
 Debug information for the MIA command lines tools. These tools provide the 
 means to run general purpose image processing tasks on 2D and 3D gray scale 
 images, and basic operations on triangular meshes from the command line. 
 Supported image processing algorithms are image filtering, combining, image 
 registration, motion compensation for image series, and the estimation of 
 various statistics over images.
